/**
   waiting connection from client
   it prints msg from client to stdout
   
   to quickly test this program, you can use telnet

   # ./simple_tcp_server 1234    #<- 1234 is portnumber
   
   # telnet serverip 1234
*/

#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <unistd.h>
#include <signal.h>

static int sock;

static void finalize(int n)
{
  close(sock);
  printf("terminated\n");
  exit(1);
}


static int recv_msg(int port)
{
  struct sockaddr_in c_addr, s_addr;
  int c_len;

  printf("port: %d\n",port);

  sock = socket( AF_INET, SOCK_STREAM, 0);
  if(sock<0) {
    printf("Unable to open socket");
    return -1;
  }

  s_addr.sin_family = AF_INET;
  s_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  s_addr.sin_port = htons(port);

  if(bind(sock, (struct sockaddr *) &s_addr, sizeof(s_addr))<0) {
    printf("Unable to bind port ");
    return -1;
  }

  listen(sock,0);

  while(1) {
    char buf[256];
    int n;
    int s2;

    c_len = sizeof(c_len);
    s2 = accept(sock, (struct sockaddr *) &c_addr, &c_len);

    while(1) {
      bzero( (void*)buf, sizeof(buf) );
      n = recv(s2, buf, sizeof(buf),0);

      if( n<0 ) {
	printf("Unable to receive data\n");
	return -1;
      } else if(n==0) {
	printf("\nclosed by client\n");
	close(s2);
	break;
      } else if( buf[0] == 0x04 ) { /* Ctrl+D */
	close(s2);
	break;
      } else {
	printf("%s", buf);
      }
    }
  }
}


int main(int argc, char* argv[])
{
  if( argc < 2 ) {
     fprintf(stderr,"%s port\n", argv[0]);
     exit(0);
  }

  signal(SIGINT, finalize);
  
  return recv_msg( atoi(argv[1]) ); 
}


// Kazutomo Yoshii < kazutomo@mcs.anl.gov >
